# neutron_lib.agent.l3_extension module

class neutron_lib.agent.l3_extension.L3AgentExtension

  Bases: `AgentExtension`

  Define stable abstract interface for l3 agent extensions.

  An agent extension extends the agent core functionality.

  abstractmethod add_router(context, data)

    Handle a router add event.

    Called on router create.

    Parameters:

      - context – RPC context.

      - data – Router data.

  abstractmethod delete_router(context, data)

    Handle a router delete event.

    Parameters:

      - context – RPC context.

      - data – Router data.

  abstractmethod ha_state_change(context, data)

    Change router state from agent extension.

    Called on HA router state change.

    Parameters:

      - context – rpc context

      - data – dict of router_id and new state

  abstractmethod update_network(context, data)

    Handle a network update event.

    Called on network update.

    Parameters:

      - context – RPC context.

      - data – dict of network data.

  abstractmethod update_router(context, data)

    Handle a router update event.

    Called on router update.

    Parameters:

      - context – RPC context.

      - data – Router data.

this page last updated: 2026-03-03 11:51:03

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug